{-# LANGUAGE ForeignFunctionInterface #-}

#include <bindings.dsl.h>
#include <nettle/cast128.h>

module Bindings.Nettle.Cipher.CAST128 where
#strict_import

#num CAST128_BLOCK_SIZE
#num CAST5_MIN_KEY_SIZE
#num CAST5_MAX_KEY_SIZE
#num CAST128_KEY_SIZE

#starttype struct cast128_ctx
#stoptype

#ccall cast5_set_key , Ptr <struct cast128_ctx> -> CUInt -> Ptr CUChar -> IO ()
#ccall cast128_set_key , Ptr <struct cast128_ctx> -> Ptr CUChar -> IO ()
#ccall cast128_encrypt , Ptr <struct cast128_ctx> -> CUInt -> Ptr CUChar -> Ptr CUChar -> IO ()
#ccall cast128_decrypt , Ptr <struct cast128_ctx> -> CUInt -> Ptr CUChar -> Ptr CUChar -> IO ()
